// System descriptions
#define MAX 201           // max side length is 200
//#define MAX 3
#define MAXNUMBER MAX*MAX // max number of individuals
#define MAX_SEARCH 100000 // Interrupt if solution has not been found after all those steps
#define NONE -1
#define FIRST 0

// Gene descriptions
#define GENESIZE 24       // Bits in each gene
#define GENES 2
#define MAXGENE 0xFFFFFF  // 16777215
#define EMPTY 0
//#define INITIAL 0xAAAAAA  // = 101010101010101010101010

// Views
#define SPECIES 1
#define COMMONEST 2
#define STRENGTH 3
#define SMALLSTEP 0.01    // for display of strength
#define BIGSTEP 0.092

unsigned long Initial_genes[ GENES];

// 8 green colors                              BBGGRR
TColor Greencolors[] = { (Graphics::TColor)0x0000FF00, // Pure green
                         (Graphics::TColor)0x0000C832,
                         (Graphics::TColor)0x00009632,
                         (Graphics::TColor)0x00006432,
                         (Graphics::TColor)0x00003232,
                         (Graphics::TColor)0x00006464,
                         (Graphics::TColor)0x00009696,
                         (Graphics::TColor)0x0000C8C8,
                       },

// 10 red colors including pure yellow         BBGGRR
        Redcolors[] =  { (Graphics::TColor)0x0000FFFF, // Pure yellow
                         (Graphics::TColor)0x0000C8FF,
                         (Graphics::TColor)0x000096FF,
                         (Graphics::TColor)0x000064FF,
                         (Graphics::TColor)0x000032FF,
                         (Graphics::TColor)0x000000FF, // Pure red
                         (Graphics::TColor)0x000000C8,
                         (Graphics::TColor)0x00000096,
                         (Graphics::TColor)0x00000064,
                         (Graphics::TColor)0x00000032,
                        };

unsigned int Side,          // Max 100 means max 10 000 positions
             Max_strength;  // The largest value found

                   // Position    Layer



// The bit to be changed by a mutation
unsigned long Mutationmask[] = { 0x000001, 0x000002, 0x000004, 0x000008,
                                 0x000010, 0x000020, 0x000040, 0x000080,
                                 0x000100, 0x000200, 0x000400, 0x000800,
                                 0x001000, 0x002000, 0x004000, 0x008000,
                                 0x010000, 0x020000, 0x040000, 0x080000,
                                 0x100000, 0x200000, 0x400000, 0x800000,
                               };

bool Gene_coupling;

int Dominant,
    Duration,
    Mutations,
    Old_population,
    Population,
    Total_generations,
    View = SPECIES;

double Fitness,
       Max_gene_sum,
       Mutationprobability;

void Catastrophe(),
     Create(),
     Draw(),
     Draw_commonest(),
     Draw_species(),
     Draw_strength(),
     Fight(),
     Mutate(),
     One_generation(),
     Optimization(),
     Search99(),
     Speciation(),
     Spread_seeds( int x, int y );

float Find_favor();

TColor Get_gene_color( int red, int green, int blue );
