void Draw()
{
 switch( View )
 {
  case SPECIES:
   Draw_species();
  break;

  case COMMONEST:
   Draw_commonest();
  break;

  case STRENGTH:
   Draw_strength();
  break;
 }
}

void Draw_strength()
{
 int steps,
     x,
     y;

 TColor speciescolor;

 for( x = 0; x < Side; x++ )
  for( y = 0; y < Side; y++ )
  {
   if( World[ x ][ y ].plant > NONE )
   {
    // First decide on color
    // Pure green at 99% or better
    // Dark brown at 9.2% or worse
    if( Individual[ World[ x ][ y ].plant ].strength > 0.92 )
    {
     // Classification step length is 1% above 99% of max strength
     steps = ( 1 - Individual[ World[ x ][ y ].plant ].strength ) / SMALLSTEP;
     speciescolor = Greencolors[ steps ];
    }
    else
    {
     // Classification step length is 9.2% below 92% of max strength
     steps = ( 0.92 - Individual[ World[ x ][ y ].plant ].strength ) / BIGSTEP;
     speciescolor = Redcolors[ steps ];
    }
   }
   else
    speciescolor = clBtnFace;  // Draw background color if the cell is empty
   Filled_circle_2d( x + 0.1, y + 0.1, x + 0.9, y + 0.9,
                     speciescolor, speciescolor );
  }
}

void Draw_species()
{
 int blue,   // Blue component gene 0, later a combination
     blue1,  // Blue component gene 1
     green,
     red,
     species,
     x,
     y;

 TColor speciescolor;

 for( x = 0; x < Side; x++ )
  for( y = 0; y < Side; y++ )
  {
   if( World[ x ][ y ].plant > NONE )
   {
    species = Individual[ World[ x ][ y ].plant ].species;
    blue =  species & 0xC;  // 000000000000xx00
    blue = blue >> 2;       // 00000000000000xx
    blue1 = species & 0xC0; // 00000000xx000000
    blue1 = blue1 >> 6;     // 00000000000000xx
    blue +=blue1;
    if( blue < 6 )   // Then a very inefficient species
    {
     red = 0;
     green = 0;
     blue *= 51;  // Pure blue if blue component = 5;
    }
    else
    {
     green = species & 3;    // 00000000000000xx
     red = species & 0x30;   // 0000000000xx0000
     blue = 0;
    }
    speciescolor = Get_gene_color( red, green, blue );
   }
   else
    speciescolor = clBtnFace;

   Filled_circle_2d( x + 0.1, y + 0.1, x + 0.9, y + 0.9,
                     speciescolor, speciescolor );
  }
}

void Draw_commonest()
{
 int blue,   // Blue component gene 0, later a combination
     blue1,  // Blue component gene 1
     green,
     red,
     species,
     x,
     y;

 TColor speciescolor;

 for( x = 0; x < Side; x++ )
  for( y = 0; y < Side; y++ )
  {
   if( World[ x ][ y ].plant > NONE )
   {
    species = Individual[ World[ x ][ y ].plant ].species;
    if( species == Dominant )
    {
     green = species & 3;    // 00000000000000xx
     blue =  species & 0xC;  // 000000000000xx00
     blue = blue >> 2;       // 00000000000000xx
     red = species & 0x30;   // 0000000000xx0000
     blue1 = species % 0xC0; // 00000000xx000000
     blue1 = blue >> 6;      // 00000000000000xx
     blue = blue | blue1;    // 1 in any of them gives 1 in the result
     speciescolor = Get_gene_color( red, green, blue );
    }
    else speciescolor = BLUE;
   }
   else
    speciescolor = clBtnFace;

   Filled_circle_2d( x + 0.1, y + 0.1, x + 0.9, y + 0.9,
                     speciescolor, speciescolor );
  }
}

TColor Get_gene_color( int r, int g, int b )
{
 unsigned long blue,
               green,
               red;

 if( r + g > 0 )
 {
  // Determine red intensity
  switch( r )  // 110000
  {
   case 0:
    red = 0x40;
   break;

   case 0x10:
    red = 0x80;
   break;

   case 0x20:
    red = 0xC0;
   break;

   case 0x30:
    red = 0xFF;
  }
  // Determine green intensity
  switch( g )  // 0011
  {
   case 0:
    green = 0x4000;
   break;

   case 1:
    green = 0x8000;
   break;

   case 2:
    green = 0xC000;
   break;

   case 3:
    green = 0xFF00;
  }

  blue = 0;
 }
 else
  blue = b << 16;
  // Determine blue intensity
/*  switch( b )
  {
   case 0:
    blue = 0xC00000; //
   break;

   case 1:
    blue = 0x800000;
   break;

   case 2:
    blue = 0x400000;  //
   break;

   case 3:
    blue = 0x000000;  // 0
  }
*/
 return( (Graphics::TColor)(red + green + blue) );
}

